#include "sphere.h"

#include <math.h>
#include <assert.h>

void sphere_init(struct sphere* s,float centre_x,
                 float centre_y,
                 float centre_z,
                 float rayon)
{
    assert(rayon>0);

    s->a=-2.0f*centre_x;
    s->b=-2.0f*centre_y;
    s->c=-2.0f*centre_z;
    s->d=centre_x*centre_x+centre_y*centre_y+centre_z*centre_z
            -rayon*rayon;

}

float sphere_volume(const struct sphere* s)
{
    float x0=-s->a/2.0f;
    float y0=-s->b/2.0f;
    float z0=-s->c/2.0f;

    float R=sqrt(x0*x0+y0*y0+z0*z0-s->d);

    assert(R>0);

    return 4.0f/3.0f*M_PI*(R*R*R);
}
